#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,m,u,v;
    cin>>n>>m;
    vector<int> a(m),b(m),t(m);
    for(int i=0;i<m;i++)
        cin>>a[i]>>b[i]>>t[i];
    int br=0;
    cin>>u>>v;
    int tstaro=0;
    bool da=false;
    for(int i=0;i<m-1;i++)
    {

        if(a[i]==a[i+1])
        {
            if(b[i]>b[i+1])
                {
                    if(t[i]!=tstaro)
                        {
                            br++;
                            tstaro=t[i];
                        }
                }
        }
        else
        if(a[i]<a[i+1])
        {
            if(t[i]!=tstaro)
            {
                br++;
                tstaro=t[i];
            }
            u=u+1;
        }
        else
            i++;
        if(u==v-1)
        {
            da=true;
            cout<<br;
            break;
        }
    }
    if(!da)
        cout<<"-1";
    return 0;
}